<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_support_reply.php                                  ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("support");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_support_reply.html");

	$admin_support_url = new VA_URL("admin_support.php", false);
	$admin_support_url->add_parameter("s_w", REQUEST, "s_w");
	$admin_support_url->add_parameter("s_s", REQUEST, "s_s");
	$admin_support_url->add_parameter("sort_ord", REQUEST, "sort_ord");
	$admin_support_url->add_parameter("sort_dir", REQUEST, "sort_dir");
	$t->set_var("admin_support_url", $admin_support_url->get_url());

	$admin_support_url->add_parameter("support_id", REQUEST, "support_id");
	$return_page = $admin_support_url->get_url("admin_support_reply.php");

	$admin_support_url->add_parameter("rp", CONSTANT, $return_page);
	$admin_support_request_url = $admin_support_url->get_url("admin_support_request.php");
	$t->set_var("admin_support_request_url", $admin_support_request_url);

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_support_reply_href", "admin_support_reply.php");
	$t->set_var("admin_support_message_href", "admin_support_message.php");
	$t->set_var("admin_support_request_href", "admin_support_request.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("site_url", $settings["site_url"]);

	$t->set_var("rnd", time());

	$support_id = get_param("support_id");
	$operation = get_param("operation");
	$rnd = get_param("rnd");

	//$return_page = "admin_support_reply.php?support_id=" . $support_id;

	$sql  = " SELECT s.user_id,s.user_name, s.user_email, s.remote_address, s.identifier, ";
	$sql .= " s.environment, p.product_name, st.type_name, s.summary, s.description, ";
	$sql .= " ss.status_name, sp.priority_name, s.date_added, s.date_modified, ";
	$sql .= " aa.admin_name as assign_to ";
	$sql .= " FROM (((((" . $table_prefix . "support s ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_products p ON p.product_id=s.support_product_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=s.support_status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id=s.support_type_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_priorities sp ON sp.priority_id=s.support_priority_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "admins aa ON aa.admin_id=s.admin_id_assign_to) ";
	$sql .= " WHERE s.support_id=" . $db->tosql($support_id, INTEGER);

	$db->query($sql);
	if($db->next_record())
	{
		$t->set_var("user_id", $db->f("user_id"));
		$user_name = $db->f("user_name");
		$t->set_var("user_name", $user_name);
		$user_email = $db->f("user_email");
		$t->set_var("user_email", $db->f("user_email"));
		$t->set_var("identifier", htmlspecialchars($db->f("identifier")));
		$t->set_var("environment", htmlspecialchars($db->f("environment")));
		$t->set_var("remote_address", $db->f("remote_address"));
		$product_name = $db->f("product_name");
		$t->set_var("product_name", $product_name);
		$t->set_var("product", $product_name);

		$t->set_var("assign_to", $db->f("assign_to"));
		$t->set_var("type", $db->f("type_name"));
		$current_status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
		$t->set_var("current_status", $current_status);
		$priority = strlen($db->f("priority_name")) ? $db->f("priority_name") : "Normal";
		$t->set_var("priority", $priority);
		$date_modified = $db->f("date_modified", DATETIME);
		$date_modified_string = va_date($datetime_show_format, $date_modified);
		$t->set_var("date_modified", $date_modified_string);

		$date_added = $db->f("date_added", DATETIME);
		$date_added_string = va_date($datetime_show_format, $date_added);
		$t->set_var("request_added", $date_added_string);
		$t->set_var("summary", htmlspecialchars($db->f("summary")));
		$description = $db->f("description");
		$t->set_var("request_description", nl2br(htmlspecialchars($description)));
		$last_message = $description;

		$sql  = " UPDATE " . $table_prefix . "support_messages SET date_viewed=" . $db->tosql(va_time(), DATETIME);
		$sql .= " WHERE support_id=" . $db->tosql($support_id, INTEGER);
		$sql .= " AND admin_id_assign_by IS NULL AND date_viewed IS NULL";
		$db->query($sql);

		$vc = md5($support_id . $date_added[3].$date_added[4].$date_added[5]);
	}
	else
	{
		header("Location: admin_support.php");
		exit;
	}

	$r = new VA_Record($table_prefix . "support_messages");

	$support_statuses = get_db_values("SELECT * FROM " . $table_prefix . "support_statuses", array(array("", "Select Status")));
	$admins = get_db_values("SELECT admin_id,admin_name FROM " . $table_prefix . "admins ", array(array("", "")));

	$r->add_textbox("support_id", INTEGER);

	$r->add_hidden("s_w", TEXT);
	$r->add_hidden("s_s", TEXT);
	$r->add_hidden("sort_ord", TEXT);
	$r->add_hidden("sort_dir", TEXT);

	$r->add_checkbox("internal", INTEGER);
	$r->add_select("admin_id_assign_to", INTEGER, $admins);
	$r->add_select("support_status_id", INTEGER, $support_statuses, "Status");
	$r->change_property("support_status_id", PARSE_NAME, "response_status");
	$r->parameters["support_status_id"][REQUIRED] = true;
	$r->add_textbox("admin_id_assign_by", INTEGER);
	$r->add_textbox("message_text", TEXT, "Message");
	$r->change_property("message_text", PARSE_NAME, "response_message");
	$r->parameters["message_text"][REQUIRED] = true;
	$r->add_textbox("date_added", DATETIME);

	$r->get_form_values();

	$errors = "";

	$session_rnd = get_session("session_rnd");
	$operation = get_param("operation");
	$rnd = get_param("rnd");

	if($operation && $rnd != $session_rnd)
	{

		$is_valid = $r->validate();

		if($is_valid)
		{
			$date_added = va_time();
			$r->set_value("date_added", $date_added);
			$r->set_value("admin_id_assign_by", get_session("session_admin_id"));

			if($r->insert_record())
			{ 
				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='support'";
				$db->query($sql);
				while($db->next_record()) { 
					$support_settings[$db->f("setting_name")] = $db->f("setting_value");
				}

				$date_added_string = va_date($datetime_show_format, $date_added);
				$support_url = $settings["site_url"] . "support_messages.php?support_id=" . $support_id . "&vc=" . $vc;

				if(!$r->is_empty("admin_id_assign_to")) {
					$sql = " SELECT admin_name FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql($r->get_value("admin_id_assign_to"), INTEGER);
					$assign_to = get_db_value($sql);
					$t->set_var("assign_to", $assign_to);
				}

				$current_status = get_array_value($r->get_value("support_status_id"), $support_statuses);
				$t->set_var("status", $current_status);
				$t->set_var("current_status", $current_status);
				$t->set_var("vc", $vc);
				$t->set_var("support_url", $support_url);
				$t->set_var("message_added", $date_added_string);
				$t->set_var("date_modified", $date_added_string);
				$t->set_var("description", $description);
				$t->set_var("message_text", $r->get_value("message_text"));

				// send email notification to admin
				if($support_settings["admin_notification"] && $r->get_value("admin_id_assign_to"))
				{
					$t->set_block("admin_subject", $support_settings["admin_subject"]);
					$t->set_block("admin_message", $support_settings["admin_message"]);

					$admin_email = get_db_value("SELECT email FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql($r->get_value("admin_id_assign_to"), INTEGER));

					$r->set_parameters();
			  
					$mail_from = get_setting_value($support_settings, "admin_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($support_settings, "cc_emails");
					$mail_bcc = get_setting_value($support_settings, "admin_mail_bcc");
					$mail_reply_to = get_setting_value($support_settings, "admin_mail_reply_to");
					$mail_return_path = get_setting_value($support_settings, "admin_mail_return_path");
					$mail_type = get_setting_value($support_settings, "admin_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					$t->parse("admin_subject", false);
					$t->parse("admin_message", false);

					$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
					mail($admin_email, $t->get_var("admin_subject"), $admin_message, $email_headers);
				}


				if(!$r->get_value("internal"))
				{
					// send email notification to user
					$t->set_block("user_subject", $support_settings["user_subject"]);
					$t->set_block("user_message", $support_settings["user_message"]);
			  
					$r->set_parameters();
			  
					$mail_from = get_setting_value($support_settings, "user_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($support_settings, "user_mail_cc");
					$mail_bcc = get_setting_value($support_settings, "user_mail_bcc");
					$mail_reply_to = get_setting_value($support_settings, "user_mail_reply_to");
					$mail_return_path = get_setting_value($support_settings, "user_mail_return_path");
					$mail_type = get_setting_value($support_settings, "user_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					$t->parse("user_subject", false);
					$t->parse("user_message", false);

					$user_message = str_replace("\r", "", $t->get_var("user_message"));
					mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
				}
			  
        // update support request info
				$sql  = " UPDATE " . $table_prefix . "support SET support_status_id=" . $db->tosql($r->get_value("support_status_id"), INTEGER);
				if(!$r->is_empty("admin_id_assign_to")) {
					$sql .= " , admin_id_assign_by=" . $db->tosql($r->get_value("admin_id_assign_by"), INTEGER);
					$sql .= " , admin_id_assign_to=" . $db->tosql($r->get_value("admin_id_assign_to"), INTEGER);
				}
				$sql .= " , date_modified=" . $db->tosql(va_time(), DATETIME);
				$sql .= " WHERE support_id=" . $db->tosql($support_id, INTEGER);
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
		else
		{
			//$errors .= "Please provide information in the sections with red, italicized headings, then click 'Submit'.<br>";	
			set_session("session_rnd", "");
		}
	}
	else // new message (set default values)
	{

	}

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_support_reply.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "support_messages WHERE support_id=" . $db->tosql($support_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT sm.admin_id_assign_by,sm.message_id,a.admin_name,ss.status_name, ";
	$sql .= " sm.message_text, sm.date_added, sm.date_viewed, sm.internal, aa.admin_name as assign_to ";
	$sql .= " FROM (((" . $table_prefix . "support_messages sm ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=sm.support_status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "admins a ON a.admin_id=sm.admin_id_assign_by) ";
	$sql .= " LEFT JOIN " . $table_prefix . "admins aa ON aa.admin_id=sm.admin_id_assign_to) ";
	$sql .= " WHERE sm.support_id=" . $db->tosql($support_id, INTEGER);
	$sql .= " ORDER BY sm.date_added DESC ";

	$db->query($sql);
	if($db->next_record())
	{

		$admin_support_url->remove_parameter("rp");
		$admin_support_url->add_parameter("message_id", DB, "message_id");
		$last_message = $db->f("message_text");
		$t->set_var("support_id", $support_id);

		do
		{
			$t->set_var("admin_support_message_url", $admin_support_url->get_url("admin_support_message.php"));
			$status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
			$t->set_var("status", $status);
			$t->set_var("message_id", $db->f("message_id"));

			if(strlen($db->f("admin_id_assign_by")))
			{
				$posted_by = $db->f("admin_name");
				$viewed_by = "Customer";
			}
			else 
			{
				$posted_by = strlen($user_name) ? $user_name . " &lt;" . $user_email . "&gt;" : $user_email;
				$viewed_by = "Admin";
			}
			if(strlen($db->f("assign_to"))) {
				$t->set_var("message_assign_to", $db->f("assign_to"));
				$t->parse("assign_to_block", false);
			} else {
				$t->set_var("assign_to_block", "");
			}	
			if($db->f("internal") == 1) {
				$t->parse("internal_block", false);
			} else {
				$t->set_var("internal_block", "");
			}	

			$t->set_var("posted_by", $posted_by);
			$t->set_var("viewed_by", $viewed_by);

			$date_added = $db->f("date_added", DATETIME);
			$date_added_string = va_date($datetime_show_format, $date_added);
			$t->set_var("date_added", $date_added_string);

			$date_viewed = $db->f("date_viewed", DATETIME);
			if(is_array($date_viewed)) {
				$date_viewed_string = va_date($datetime_show_format, $date_viewed);
				$t->set_var("date_viewed", "<font color=\"blue\">" . $date_viewed_string . "</font>");
			} else {
				$t->set_var("date_viewed", "<font color=\"red\">Not viewed</font>");
			}

			$t->set_var("message_text", nl2br(htmlspecialchars($db->f("message_text"))));

			$t->parse("records", true);
		} while($db->next_record());

	}
	else
	{
		$t->set_var("records", "");
	}

	if(!strlen($operation)) // (set default message text for reply)
	{
		$last_message = ">" . str_replace("\n", "\n>", $last_message);
		$r->set_value("message_text", $last_message);
	}

	$r->set_parameters();

	$t->set_var("page", $page_number);
	$t->set_var("rp", urlencode($return_page));

	$t->pparse("main");

?>