<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_shipping_time.php                                  ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("static_tables");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_shipping_time.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->set_var("admin_shipping_times_href", "admin_shipping_times.php");
	$t->set_var("admin_shipping_time_href", "admin_shipping_time.php");

	$r = new VA_Record($table_prefix . "shipping_times");
	$r->return_page = "admin_shipping_times.php";
	

	$r->add_where("shipping_time_id", INTEGER);

	$r->add_textbox("shipping_time_desc", TEXT, "Shipping Time");
	$r->change_property("shipping_time_desc", REQUIRED, true);

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>
