<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  articles_select.php                                      ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");

	check_admin_security("articles_categories");

  	$t = new VA_Template($settings["admin_templates_dir"]);
  	$t->set_file("main","articles_select.html");

	$t->set_var("articles_upload_href", "articles_upload.php");

	$filetype = get_param("filetype");
	$operation = get_param("operation");

	$t->set_var("filetype", $filetype);

	if($filetype == "image_small")
		$image_dir = "../images/small/";
	else if($filetype == "image_large")
		$image_dir = "../images/big/";
	else if($filetype == "category_small" || $filetype == "category_large")
		$image_dir = "../images/categories/";

	if ($dir = @opendir("./" . $image_dir)) 
	{
		$dir_index = 0;
	  while($file = readdir($dir)) 
		{
			if ($file != "." && $file != ".." && is_file("./" . $image_dir . $file)) 
			{ 
				$dir_values[$dir_index] = $file;
				$dir_index++;
	    } 
	  }  
  	closedir($dir);
	}

	$image_number = isset($dir_values) ? sizeof($dir_values) : 0;
	
	if($image_number)
	{
		for($i = 0; $i < sizeof($dir_values); $i++)
		{
			$t->set_var("image_href", $image_dir . $dir_values[$i]);
			$t->set_var("image_name", $dir_values[$i]);
			$t->parse("image_row", true);
		}

		$t->set_var("no_images", "");
		$t->parse("images", false);

	}
	else
	{
		$t->parse("no_images", false);
		$t->set_var("images", "");
	}



	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");


?>